/****************************************************************
Common definitions provided by LIME in the namespace of all code 
compiled by the CUDA back-end

Copyright 2008 Pjotr Kourzanov

This file is part of LIME.

LIME is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License version 2
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

LIME is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with LIME.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/
#ifndef __CUDA__
#define __CUDA__
// this is the x.y.z version (x.y.z)=x*100^2+y*100+z of the CUDA
#define __CUDA_VERSION 2 // x.y.z=0.0.1

#if defined(__LIME__)
#include <common.h>
#include <pragmas.h>
#endif//__LIME__

#if !defined(__LIME__)
#include <LIME_common.h>
#include <LIME_pragmas.h>
#endif//!defined(LIME)

#if defined(__CUDACC__)
#define actor __device__ void
#define varrate_actor __device__ unsigned int
#define helper __device__
#endif//__CUDACC__

#if !defined(__CUDACC__)
#include <limits.h>
#define atomicInc(p,v) (*(p)= (*(p) >= v ? 0 : *(p)+1))
#define atomicAnd(p,v) (*(p)= *(p) & v)
#define actor void
#define helper
#endif//!defined(LIME)

#include <LIME_global.h>
// CUDA local policies for defaults:

Lime(type relax fold)

#endif//__CUDA__
