##################################################################
# The CUDA BE compilation flow driver (only rules)
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################
include $(lib)/LIME.mk

$d/%-run.cu: %.gxf
	$e$(gxf2run.cu) $< > $@ || $(fail)

$d:
	$e$(mkdir) -p $@

define comp-rule

$d/$1-kernel.h: $$(graphs) $d/$1.imports
	$e$(gxf2kernel.h) -vPE=$1 -vIMPORTS=$$(filter %.imports,$$^) $$< > $$@ || $(fail)

$d/$1-kernel.c: $$(graphs) $d/$1.imports
	$e$(gxf2kernel.c) -vPE=$1 -vIMPORTS=$$(filter %.imports,$$^) $$<\
		`$(sed) -e 's,$$$$,.types,g;s,^,$d/,g' $$(filter %.imports,$$^)`\
	> $$@ || $(fail)

$d/$1.mod.c: $1.c $1.pdepx.h $1.domains
	$E$(CC) $(CFLAGS) $$(call dom2hdr,$1.pdepx.h,$1.domains) $(FLAGS) -E $1.c -o $$@ 

$d/$1.imports: $1.imports
	$efor i in `$(sed) -e 's,.*,&.h,g' $$(filter %.imports,$$^)`; do\
		[ -r $$$$i ] || continue;\
		cp $$$$i $d/;\
	done
	$efor i in `$(sed) -e 's,.*,&.types,g' $$(filter %.imports,$$^)`; do\
		[ -r $$$$i ] || continue;\
		cp $$$$i $d/;\
	done
	$e$(sed) 's,.*/,,g' $$< > $$@

endef

$d/Makefile: $(src)/Makefile $d
	$e$(sed) -s 's/$$(comp)/$(graph:%.graph=%)/g' $< | $(unbundle) -vprefix=$d

$(foreach c,$(comps),$(eval $(call comp-rule,$c)))


