#!/usr/bin/awk -f
##################################################################
# Normalize XML, promote attributes to tags, keep some as attributes
# (id, xlink: stuff).
#
#Copyright 2008 Pjotr Kourzanov
#
#This file is part of LIME.
#
#LIME is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License version 2
#as published by the Free Software Foundation; either version 2
#of the License, or (at your option) any later version.
#
#LIME is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with LIME.  If not, see <http://www.gnu.org/licenses/>.
##################################################################
BEGIN {
	if (!passthrough) passthrough=1
	if (root) {
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
		if (do_dtd) print "<!DOCTYPE",root,"SYSTEM","\"" root ".dtd\">"
		printf "<%s",root 
		if (use_xlink)
			printf " xmlns:xlink='http://www.w3.org/1999/xlink' xlink:type='%s'",use_xlink
		print ">"
	}
}

func handle(t,b) {
    	if (DEBUG) print "NORM: handling tag","<" t ">","body","'" b "'","in",state >STDERR
	# remove history
	delete id[lev+1]
	if (t=="@id") {
		for (j=lev-1;j>0;j--) 
			b=unquote(id[j]) ":" b
		return b
	}
	# remove history
	delete label[lev+1]
	if (t=="@xlink:label") {
		b=append(unquote(label[lev-1]),b,":")
		return label[lev]=b
	}
	if (t=="id") return id[lev]=b
	return b 
}

END {
	if (root) print "</" root ">"
}

@include xml-parser.awk
